<template>
  <div
    @mousedown="
      $emit('setDragTask', { taskId: task.id, x: $event.x, y: $event.y })
    "
    class="task-item"
  >
    <div class="task-item-header">
      <p class="task-item-title" :title="shortTitleData.title">
        {{ shortTitleData.text }}
      </p>
      <div class="task-item-actions">
        <icon-btn color="#585858" @click="$emit('setEditableTask', task)">
          <path
            d="M 18.414062 2 C 18.158188 2 17.902031 2.0974687 17.707031 2.2929688 L 16 4 L 20 8 L 21.707031 6.2929688 C 22.098031 5.9019687 22.098031 5.2689063 21.707031 4.8789062 L 19.121094 2.2929688 C 18.925594 2.0974687 18.669937 2 18.414062 2 z M 14.5 5.5 L 3 17 L 3 21 L 7 21 L 18.5 9.5 L 14.5 5.5 z"
          ></path
        ></icon-btn>
        <icon-btn color="#e30000" @click="remove(task.id)"
          ><path
            d="M 10 2 L 9 3 L 3 3 L 3 5 L 21 5 L 21 3 L 15 3 L 14 2 L 10 2 z M 4.3652344 7 L 5.8925781 20.263672 C 6.0245781 21.253672 6.877 22 7.875 22 L 16.123047 22 C 17.121047 22 17.974422 21.254859 18.107422 20.255859 L 19.634766 7 L 4.3652344 7 z"
          ></path
        ></icon-btn>
      </div>
    </div>

    <p class="task-item-user">Assigned to {{ task.user.name }}</p>
    <p class="task-item-desc" :title="shortDescData.title">
      {{ shortDescData.text }}
    </p>
    <p class="task-item-days">
      <span v-if="task.daysLeft > 0" class="task-item-days-active"
        >Days left {{ task.daysLeft }}</span
      >
      <span v-else>Time is over</span>
    </p>
  </div>
</template>

<script>
import { mapMutations } from "vuex";
import IconBtn from "./IconBtn";

export default {
  name: "TaskItem",
  components: { IconBtn },
  props: { task: { type: Object } },
  methods: {
    ...mapMutations(["remove"]),
    getShortData(origString, maxLength) {
      const isOverflow = origString.length > maxLength;
      return {
        text: isOverflow
          ? `${origString.substr(0, maxLength + 3)}...`
          : origString,
        title: isOverflow ? origString : null,
      };
    },
  },
  computed: {
    shortDescData() {
      return this.getShortData(this.task.description, 45);
    },
    shortTitleData() {
      return this.getShortData(this.task.name, 25);
    },
  },
};
</script>

<style scoped>
.task-item {
  padding: 2rem 1.6rem;
  display: grid;
  grid-template-columns: 1fr;
  row-gap: 0.8rem;
}
.task-item-header {
  display: flex;
  align-items: flex-start;
  justify-content: space-between;
}
.task-item-title {
  font-size: 20px;
}
.task-item-user {
  color: #9e9e9e;
  font-size: 12px;
  font-weight: bold;
}
.task-item-days {
  color: #9e9e9e;
}
.task-item-days-active {
  color: #4181ff;
}
.task-item-actions {
  display: flex;
  flex-direction: row;
  flex-wrap: nowrap;
}
</style>
